package com.react_sqlconnectionpackage.sqlconnection;

import android.content.Context;
import android.content.ContextWrapper;
import android.database.sqlite.SQLiteDatabase;

import java.io.File;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.ArrayList;


public class DatabaseHandler extends SQLiteDatabaseHandler {
    public static final String DATABASE_NAME = "database.db";
    public static   String DB_PATH = "";
    public static final int DATABASE_VERSION = 1;

    public static ArrayList<String> tables=new ArrayList<>();
    Context context;


    public DatabaseHandler(Context c) {
        super(c, DATABASE_NAME, DATABASE_VERSION);
        context = c;

        try{
            ContextWrapper cw =new ContextWrapper(c);
            DB_PATH =cw.getFilesDir().getAbsolutePath()+ "/databases/";

        }catch(Exception e){GlobalData.printError(e);}

    }



    @Override
    public void createTable(SQLiteDatabase db) {



        // added inside DB version 1

        try{
      //      copyDataBase();

//            for (int i=0;i<tables.size();i++) {
//
//                try {
//                    db.execSQL(tables.get(i));
//                } catch (Exception e) {
//                }
//            }

        }catch(Exception e){
//            GlobalData.printError( e);
        }
    }




    @Override
    public void updateDatabase(Context ourContext, SQLiteDatabase db,
                               int oldVersion, int newVersion) {

        // db.execSQL("DROP TABLE IF IT EXISTS " + DATABASE_NAME);
        // createTable(db);
        switch (oldVersion) {

        }
    }

    public void initDatabase() {
        open();
        close();
    }


    private void copyDataBase()
    {

        try{

            GlobalData.printMessage("Database New database is being copied to device!");

            byte[] buffer = new byte[1024];
            OutputStream myOutput = null;
            int length;
            // Open your local db as the input stream
            InputStream myInput = null;
            try
            {
                myInput =context.getAssets().open(DATABASE_NAME);
                // transfer bytes from the inputfile to the
                String filePath=DB_PATH+ DATABASE_NAME;
                try{
                    File f=new File(filePath);

                    if(!f.exists()){
                        f.createNewFile();
                    }


                }catch(Exception e){GlobalData.printError(e);}
                // outputfile
                myOutput =new FileOutputStream(DB_PATH+ DATABASE_NAME);
                while((length = myInput.read(buffer)) > 0)
                {
                    myOutput.write(buffer, 0, length);
                }
                myOutput.close();
                myOutput.flush();
                myInput.close();
                GlobalData.printMessage("Database New database has been copied to device!");

                GlobalData.backupDBtoSDCard(context);

            }
            catch(Exception e)
            {
                e.printStackTrace();
            }

        }catch(Exception e){GlobalData.printError(e);}
    }
}
